Ruby master - Bug #7881

Windows 0100000000000000000 require00000
02/19/2013 11:37 AM - 5.5 (5 5)

Status: Closed
Priority: Normal
Assignee: h.shirosaki (Hiroshi Shirosaki)

Target version:

ruby -v: ruby 1.9.3p385 (2013-02-06) Backport: 2.3: UNKNOWN, 2.4: UNKNOWN, 2.5:
[i386-mingw32] UNKNOWN

Description

=begin

gi
Windows 000000000000000000 require 0000000

Ruby 1.9.3 [ p374llp3ss N000000000000p125 000000000
p2ge6 00000000000000000000

qoooon

(1) o000 000000000000
2) dv/000/a.r0 0000000000
) d/000/0.r0 0000000000
) cd /000

)

(2

(3
(4
(5) ruby a.rb

a.rb 0000

# encoding: utf-8
require "./b"

b.ro 000

# encoding: utf-8
puts "No problem."

ooao
cannot load such file -- ./b (LoadError)
goooo
« (00000000000000testd0OO0OODOODOODDO
« arb 00000000000000 cpes2 00OODDODDODOOD

« require "./b" [l require "./b".encode("CP932") [00000DODDDDODD
. DDDDDDDDDDD gem 00000 require 0000

=end

History

#1 - 02/22/2013 08:48 AM - ko1 (Koichi Sasada)
- Category set to core

- Assignee set to usa (Usaku NAKAMURA)
usa 000 naruse 00000000000000000000 usa 00DOOODD

#2 - 02/25/2013 03:11 PM - usa (Usaku NAKAMURA)
- Status changed from Open to Assigned

- Assignee changed from usa (Usaku NAKAMURA) to h.shirosaki (Hiroshi Shirosaki)

00000000000windowsrequire100000000000000000
000DoDoDoooononon.
#3 - 02/26/2013 10:19 AM - naruse (Yui NARUSE)

- Target version changed from 1.9.3 to 2.6

#4 - 02/27/2013 07:02 PM - h.shirosaki (Hiroshi Shirosaki)

=begin
Windowsllexpand_pathllencodingl00000000

osx[lcurrent directorylpath10000000000encodingd000000WindowsOO000000000000000

$ cat test_expand_path.rb

# coding: sjis

p File.expand_path("./a")

p File.expand_path("./a").encoding

$ ruby -v test_expand_path.rb

ruby 2.1.0dev (2013-02-27 trunk 39526) [x86_64-darwin12.2.0]
"/Users/hiroshi/work/a"

#Encoding:Windows-31J

$cd 000

$ ruby -v ../test_expand_path.rb

ruby 2.1.0dev (2013-02-27 trunk 39526) [x86_64-darwin12.2.0]
"/Users/hiroshi/work/0/a"

#Encoding:UTF-8

=end

#5 - 02/27/2013 07:38 PM - usa (Usaku NAKAMURA)

=begin
000000windows0000000O00000DIocalellexpand_path00000000000000000000000

0000000000a000no0nonno0n0a+.9.300000000000000DO0DOO0DO00GD
2.0.00... 0000000ODD

C:>type a.rb

# coding: utf-8

unless ".respond_to?("encoding")
class String

def encoding

"dummy"

end

end

end

path = File.expand_path("./a")
p [path, path.encoding]

C:> ruby187p371 -v a.rb
ruby 1.8.7 (2012-10-12 patchlevel 371) [i386-mswin32]
['C:/a", "dummy"]

C:> ruby193p0 -v a.rb
ruby 1.9.3p0 (2011-10-30 revision 33570) [x64-mswin64_100]
["C:/a", #Encoding:Windows-31J]

C:> ruby193p392 -v a.rb
ruby 1.9.3p392 (2013-02-22 revision 39386) [x64-mswin64_100]

['C:/a", #Encoding:UTF-8]

C:> ruby200p0 -v a.rb
ruby 2.0.0p0 (2013-02-24 revision 39474) [x64-mswin64_100]
['C:/a", #Encoding:UTF-8]

C:>cd 000

A0S ruby187p371 -v arb

ruby 1.8.7 (2012-10-12 patchlevel 371) [i386-mswin32]
["C:N202\304\202\267\202\306/a", "dummy"]

000> ruby193p0 -v a.rb
ruby 1.9.3p0 (2011-10-30 revision 33570) [x64-mswin64_100]
["c+/000/a", #Encoding:Windows-31J]

cAD00> ruby193p392 -v a.rb
ruby 1.9.3p392 (2013-02-22 revision 39386) [x64-mswin64_100]
["C:\u3066\u3059\u3068/a", #Encoding:UTF-8]

cAD00> ruby200p0 -v a.rb

ruby 2.0.0p0 (2013-02-24 revision 39474) [x64-mswin64_100]
["C:Au3066\u3059\u3068/a", #Encoding:UTF-8]

=end

#6 - 02/27/2013 08:38 PM - h.shirosaki (Hiroshi Shirosaki)
usa (Usaku NAKAMURA) wrote:
000000windows0000D000O00000DIocalellexpand_path00000000000000000000000
1.9.30unix00010calel0000000000000000windowsl0backportl0000000002.0.0000)000000000000000DO000DOD
encodinglllllfile system encodingl00000000000000¢cp0path_encodingllfile system encodingl00000000000
https://github.com/ruby/ruby/blob/trunk/win32/file.c#L.584

Q000000000o00no0nannoon0a4.e.300000000000000DO00CO0DO00DD
2.0.00... 000000OODD

c:AU00> ruby200p0 -v a.rb
ruby 2.0.0p0 (2013-02-24 revision 39474) [x64-mswin64_100]
["C:Au3066\u3059\u3068/a", #Encoding:UTF-8]

trunklosx0000000000000encodinglwindows-31J0000000000000000000000000002
#7 - 02/28/2013 05:59 PM - usa (Usaku NAKAMURA)
0oooooponddooo

In message "[ruby-dev:47123] [ruby-trunk - Bug #7881] Windows 000000000000000000 require 00000
on Feb.27,2013 20:38:05, h.shirosaki@gmail.com wrote:

000000windows000D0000O00000DIocalelexpand_path00000000000000000000000
1.9.30unix0000iocale00000000000000000windowslbackportl0O000000002.0.0000)0000000000000000000000

00000000O000000000Dononanang
00000DoDoDoooonoDoDoDoD

encodingDDDfiIe system encodingﬂﬂDDDDDDDDDDDDﬂﬂcpﬂpath_encodingﬂfile system encodingﬂﬂﬂﬂﬂﬂﬂﬂﬂﬂﬂﬂ
https:/github.com/ruby/ruby/blob/trunk/win32/file.c#l 584

00obobooooo

000000oponoononononononoD+.9.3000000000000000O0D0DODODODD
2.0.00... 000000OOOO

cA000> ruby200p0 -v a.rb

ruby 2.0.0p0 (2013-02-24 revision 39474) [x64-mswin64_100]
["C:/Au3066\u3059\u3068/a", #Encoding:UTF-8]

trunklosx0000000000000encodinglwindows-31J00000000000000000000000O0DO

000000000000000000000000O0DnanD
00000o0ooDoohonoobonoo

000000000000000002.0.000000000000
ooooooo

ooooo
U.Nakamura usa@garbagecollect.jp
https://github.com/ruby/ruby/blob/trunk/win32/file.c#L584
https://bugs.ruby-lang.org/issues/7881
mailto:h.shirosaki@gmail.com
https://github.com/ruby/ruby/blob/trunk/win32/file.c#L584
mailto:usa@garbagecollect.jp

#8 - 03/03/2013 10:49 PM - nagachika (Tomoyuki Chikanaga)
000000000D000000DFile.expand_path 000000000000000000000DO0DOODDOODOCOD

#9 - 03/05/2013 02:54 PM - h.shirosaki (Hiroshi Shirosaki)
=begin

0000000000000000000000current directory00000000000000
Encoding::CompatibilityError I00000000000000000000000000

expand_path[[00filesystem encodingl00000000000000000.encode(filesystem)0000000000000000000
# coding: euc-jp

expand = File.expand_path(ll"

p [expand, expand.encoding]

path = File.join(expand, "000")
p [path, path.encoding]

100000000require /b 0000 require_relative "b* 00000000000

=end

#10 - 12/25/2017 06:15 PM - naruse (Yui NARUSE)
- Target version deleted (2.6)

#11 - 08/08/2019 08:54 PM - jeremyevans0 (Jeremy Evans)
- Status changed from Assigned to Closed
This appears to have been fixed between Ruby 2.4 and 2.5:

D:\000>c:\Ruby24-x64\bin\ruby a.rb
a.rb: No such file or directory @ realpath_rec - D:/??? (Errno::ENOENT)

D:\000>c:\Ruby25-x64\bin\ruby a.rb
No Problem.
